import { squaredDistanceBetween } from './distance-and-length/squared-distance-between.js';


/**
 * Returns the closest point to the array of 2d points or if the array is empty
 * returns undefined.
 * @param p
 * @param ps
 */
function getClosestTo(p: number[], ps: number[][]): number[] | undefined {
    let closestPoint: number[] = undefined!; 
    let closestDistance = Number.POSITIVE_INFINITY; 
    for (let i=0; i<ps.length; i++) {
        const q = ps[i];
        
        const d = squaredDistanceBetween(p, q); 
        if (d < closestDistance) {
            closestPoint = q;
            closestDistance = d; 
        } 
    }

    return closestPoint;
}


export { getClosestTo }
